// adation of pxpath.js by sdf 2006
// introduced to thisis_a05.maxpat 20110308


inlets  = 3;
setinletassist(2,"set point(x y list)");
setinletassist(1,"from lcd dump");
setinletassist(0,"trigger");

outlets = 2;
setoutletassist(0,"to lcd");
setoutletassist(1,"RGB list for granulation");

var worldsizeX = 400; // added 2011
var worldsizeY = 400;


var myR = 256*Math.random();	//
var myG = 256*Math.random();	//  randomize starting colour
var myB = 256*Math.random();	//

var myX = Math.random()*worldsizeX;	// random starting point
var myY = Math.random()*worldsizeY;	//

var nuX = 51;	// these will be changed 
var nuY = 25;	//	before they are used

var ChngR = 10;	//	amount to change colour elements by
var ChngG = 10;	//   when the element (R,G or B) get to 
var ChngB = 10;	//	  top of range this var becomes -10

var stuckCounter = 0; // 

function bang(){		// choose which direction to try to move in
	rnd = Math.random();
	if(rnd < 0.125) N();
	else if(rnd < 0.25) NE();
	else if(rnd < 0.375) E();
	else if(rnd < 0.5) SE();
	else if(rnd < 0.625) S();
	else if(rnd < 0.75) SW();
	else if(rnd < 0.875) W();
	else NW();
}

// direction functions
		function NW(){
			nuX = myX - 1; 	
			nuY = myY - 1;
			getnu();
		}
		function N(){
			nuX = myX; 
			nuY = myY - 1;
			getnu();
		}
		function NE(){
			nuX = myX + 1; 
			nuY = myY - 1;
			getnu();
		}
		function E(){
			nuX = myX - 1; 
			nuY = myY;
			getnu();
		}
		function W(){
			nuX = myX + 1; 
			nuY = myY;
			getnu();
		}
		function SW(){
			nuX = myX - 1; 
			nuY = myY + 1;
			getnu();
		}
		function S(){
			nuX = myX; 
			nuY = myY + 1;
			getnu();
		}
		function SE(){
			nuX = myX + 1; 
			nuY = myY + 1;
			getnu();
		}
		
function getnu(){	
	outlet(0, "getpixel", nuX, nuY); // msg to lcd
}

function pixel() 	// called by message from lcd dump 
{

	
	pxX = arguments[3];
	pxY = arguments[4];
	
	//if this is the px i asked for
	if (pxX == nuX && pxY == nuY)
	{	
		pxR = arguments[0];
		pxG = arguments[1];
		pxB = arguments[2];

		//if black or void
		if (pxR == 0 && pxG == 0 && pxB == 0)
		{
			if(stuckCounter) stuckCouter=0; // reset counter
		// make a sound
			grain();	
		// move to new px
			myX = nuX;
			myY = nuY;		
		// change our colour
			changeColour();
		// set that px to our colour
			setpx();
		}
		//else if close to my colour...
		else if ( pxR < (myR+20) && pxR > (myR-20) ) //if close to R
		{
			if ( pxG < (myG+20) && pxG > (myG-20) ) //if close to G
			{
				if ( pxB < (myB+20) && pxB > (myB-20) ) //if close to B
				{
					if (stuckCounter) stuckCouter=0; // reset counter
				// move to new px
					myX = nuX;
					myY = nuY;
				}	
			}
		}
		else	//if not black or close to my colour
		{							
			stuckCounter++;	// increment counter because we could not move
			if(stuckCounter > 200)
			{		//if we think we are stuck, pop! (create some blank pixels around self)
				outlet(0, "paintoval", myX-3, myY-3, myX+3, myY+3, 0, 0, 0);
				stuckCounter=0; // reset counter
			}
		}
	}	
}

function setpx(){
	outlet(0, "setpixel", myX, myY, myR, myG, myB);
}

function grain(){			//output RGB list as seed for sound grain
	outlet(1, myR, myG, myB);
}

function changeColour(){	
	rnd = Math.random();		//which colour element to change?
	if(rnd < 0.33){			//change R
		if (myR > 255) ChngR = -10;
		else if	(myR < 0) ChngR = 10;
		myR = myR + ChngR*Math.random();
	}
	else if(rnd < 0.67){		//change G
		if (myG > 255) ChngG = -10;
		else if	(myG < 0) ChngG = 10;
		myG = myG + ChngG*Math.random();
	}
	else{				//change B
		if (myB > 255) ChngB = -10;
		else if	(myB < 0) ChngB = 10;
		myB = myB + ChngB*Math.random();
	}
}

function setloc(){			// set location of agent
	myX = arguments[0];
	myY = arguments[1];
}
function whereami(){
	post(myX, myY);
	post();
}
function anything()
{
}